
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PG_CLIENT_CONFIGURATION_H
#define PG_CLIENT_CONFIGURATION_H

class RndDistr;
class PopModel;
class RobotSym;

class CltCfg {
	public:
		CltCfg();
		void configure(const RobotSym *rs);

	protected:
		void configureServers(const RobotSym *cfg);
		void configureRTypes(const RobotSym *cfg);

	public:
		RndDistr *theOriginSel;    // selects origin hosts (set by Client)
		RndDistr *theRTypeSel;     // selects request types

		PopModel *thePopModel;     // popularity model to select old oids
		NetAddr thePeerHttp;       // caching peer talking HTTP
		NetAddr thePeerIcp;        // caching peer talking ICP
		double thePublicRatio;     // how often to request a "public" object
		double theRecurRatio;      // how often to re-visit an old object
		double theEmbedRecurRatio; // how often to re-visit an old embedded obj

		Time theLaunchWin;
		int theWaitXactLmt;        // limit on the number of postponed requests
		int theIcpPort;            // IPC client should use this port

		int theSrvCount;           // number of servers (set by Client)

		bool genUniqUrls;          // each generated URL must be unique
};

#endif
