
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PG_CLIENT_CONNECTION_MANAGER_H
#define PG_CLIENT_CONNECTION_MANAGER_H

#include "NetAddr.h"
#include "Queue.h"
#include "ConnHash.h"
#include "runtime/ConnMgr.h"

class PortMgr;

class CltConnMgr: public ConnMgr {
	public:
		CltConnMgr();
		virtual ~CltConnMgr();

		void configure(const SockOpt &anOpt, RndDistr *aPconnUseLmt, int aConnLvlLmt, int srvCnt);
		void portMgr(PortMgr *aPortMgr);

		bool atHardConnLimit() const; 
		virtual Connection *get(const NetAddr &addr);

		virtual void noteReadReady(int fd);

	protected:
		Connection *open(const NetAddr &addr);
		virtual void putIdle(Connection *conn);
		virtual void delIdle(Connection *conn);

	protected:
		ConnHash theIdleHash;
		Queue<Connection> theIdleQueue;
		PortMgr *thePortMgr;

		int theConnLvlLmt;  // limit for opened connections
};

#endif
