
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "polygraph.h"

#include "base/BStream.h"
#include "runtime/IOBuf.h"

#include "InjectIter.h"
#include "cdbEntries.h"
#include "gadgets.h"


/* CdbeText */

void CdbeText::image(const String &anImage) {
	theImage = anImage;
}

OBStream &CdbeText::store(OBStream &ol) const {
	return ol << theImage;
}

IBStream &CdbeText::load(IBStream &il) {
	return il >> theImage;
}

ostream &CdbeText::print(ostream &os) const {
	return os << theImage;
}

void CdbeText::print(CdbEntryPrnOpt &opt) const {
	const Size strLen = theImage ? theImage.len() : 0;
	const Size len = Min(strLen, opt.sizeMax, opt.buf->spaceSize());

	if (theImage && len)
		opt.buf->append(theImage, len);

	if (opt.injector)
		opt.injector->inject(*opt.buf, 0, len);
}

/* CdbeTag */

ostream &CdbeTag::print(ostream &os) const {
	return os << '<' << theImage << '>';
}

// prevent tags from breaking up
void CdbeTag::print(CdbEntryPrnOpt &opt) const {
	if (theImage) {
		const Size size = theImage.len() + 2;
		const Size space = Min(opt.sizeMax, opt.buf->spaceSize());
		if (size <= space) {
			opt.buf->append("<", 1);
			opt.buf->append(theImage, theImage.len());
			opt.buf->append(">", 1);
		} else
			opt.buf->appendRnd(space);
	}
}

