
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PG_ICP_MESSAGE_CLASS_H
#define PG_ICP_MESSAGE_CLASS_H

#include "NetAddr.h"
#include "Socket.h"
#include "base/ObjId.h"
#include "IcpOpCode.h"

// common part of ICP requests and replies
class IcpMsg {
	public:
		IcpMsg();

		int logCat() const { return theLogCat; }
		IcpOpCode opCode() const { return theOpCode; }
		int reqNum() const { return theReqNum; }
		const ObjId &oid() const { return theOid; }
		const NetAddr &peer() const { return theAddr; }
		Size size() const { return theSize; }

		void logCat(int aCat) { theLogCat = aCat; }
		void opCode(IcpOpCode anOc) { theOpCode = anOc; }
		void oid(const ObjId &anOid) { theOid = anOid; }
		void reqNum(int aReqNum) { theReqNum = aReqNum; }
		void peer(const NetAddr &anAddr) { theAddr = anAddr; }

		bool send(Socket &s) const;
		bool receive(Socket &s);

	protected:
		bool finish(int errNo);
		
	protected:
		NetAddr theAddr; // peer address
		ObjId theOid;
		int theReqNum;
		Size theSize;
		int theLogCat;
		IcpOpCode theOpCode;
};


#endif
