
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "polygraph.h"

#include "base/ILog.h"
#include "LogCatFilter.h"

#include "polyLogCats.h"


LogCatFilter::LogCatFilter(): theActiveCats(lgcEnd), theCat(lgcAll) {
	theActiveCats.count(lgcEnd);
	theActiveCats.memset(0);
}

void LogCatFilter::logCat(int aCat) {
	theCat = aCat;
}

bool LogCatFilter::passed(const LogEntryPx &px) {

	if (!theActiveCats[px.theCat])
		addCat(px.theCat);

	return
		theCat == lgcAll ||
		px.theCat == lgcAll ||
		px.theCat == theCat;
}

void LogCatFilter::addCat(int cat) {
	// find the first active category, excluding lgcAll
	int firstCat = lgcAll;
	for (int i = 1; i < theActiveCats.count() && firstCat == lgcAll; ++i) {
		if (theActiveCats[i])
			firstCat = i;
	}

	if (firstCat > lgcAll && theCat == lgcAll) {
		cerr << "warning: log(s) have info from client and server sides,"
			<< " and no specific side was specified; "
			<< " assuming `"
				<< (firstCat == lgcCltSide ? "clt" : "srv")
				<< "' side"
			<< endl;
		theCat = firstCat;
	}

	theActiveCats[cat] = true;
}
