
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PGL_BENCH_SYMBOL_H
#define PGL_BENCH_SYMBOL_H

#include "xstd/Array.h"
#include "xstd/NetAddr.h"
#include "pgl/PglRecSym.h"

class String;
class IntSym;
class PglArraySym;


// parameters for object life cycle model
class BenchSym: public RecSym {
	public:
		BenchSym();
		BenchSym(const String &aType, PglRec *aRec);

		virtual bool isA(const String &type) const;
		virtual SynSym *clone(const String &type) const;

		bool peakReqRate(double &rate) const;
		bool clientHostCount(int &count) const;
		NetAddr cltMask() const;
		NetAddr srvMask() const;
		bool maxCltLoad(double &load) const;
		bool maxRbtLoad(double &load) const;

		IntSym *clientHostCount() const;
		ArraySym *robots() const;
		ArraySym *servers() const;

	protected:
		ArraySym *sideIps(int shift) const;
		ArraySym *ipStrToArr(const String &str) const;
		String ipStr(const NetAddr &mask, int pairCnt, int agentCnt, int start) const;
		int doubleDiv(int factor, double n, double d) const;
};

#endif
