
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PG_TRANSITION_FACTOR_H
#define PG_TRANSITION_FACTOR_H

class Phase;
class GoalRec;

class TransFactor {
	public:
		TransFactor(const StatPhase *aPhase);

		void configure(double beg, double end, const TransFactor *prev);

		double beg() const { return theBeg; }
		double end() const { return theEnd; }
		bool flat() const { return !theK; }

		double current(Time lastTm, int lastCnt) const;

	protected:
		const GoalRec &goal() const;

	protected:
		const StatPhase *thePhase;

		double theBeg;
		double theEnd;
		double theK;
};


#endif
