
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef SHUTDOWN_H
#define SHUTDOWN_H

// routines that determine shutdown conditions, report them,
// and assist in nice program termination

class String;

// stop now? (checks various conditions)
extern bool ShutdownNow();

// returns true iff ShutdownNow returned true before
extern bool ShutdownRequested();

// note a shutdown signal
extern void ShutdownSignal(int s);

// force a shutdown for some reason
extern void ShutdownReason(const String &reason);

// to be registered with at_exit
extern void Shutdown();

#endif
