
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "xstd.h"
#include "xport.h"

static time_t fake_timegm(struct tm *t);

#if defined(HAVE_EXTERN_TIMEZONE)
	extern time_t timezone;
#endif


time_t xtimegm(struct tm *t) {
#	ifdef HAVE_TIMEGM
		return timegm(t);
#	else
		return fake_timegm(t);
#	endif
}

#include <iostream.h>

static
time_t fake_timegm(struct tm *t) {
	const time_t res = mktime(t);

#if defined(HAVE_TM_GMTOFF)
	const struct tm *local = localtime(&res);
	return res + local->tm_gmtoff;
#elif defined(HAVE_TIMEZONE)
	const time_t dst = t->tm_isdst > 0 ? -3600 : 0;
	return res - (xtimezone + dst);
#else
	return res;
#endif
}
